/* file_utils.c generated by valac 0.56.17, the Vala compiler
 * generated from file_utils.vala, do not modify */

#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

VALA_EXTERN void file_utils_save_to (GFile* file,
                         const gchar* text);
static guint8* _vala_array_dup3 (guint8* self,
                          gssize length);
VALA_EXTERN void file_utils_recursive_delete (GFile* path);
VALA_EXTERN gchar* file_utils_expand_home_directory (const gchar* path);

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static guint8*
_vala_array_dup3 (guint8* self,
                  gssize length)
{
	if (length > 0) {
		return g_memdup2 (self, length * sizeof (guint8));
	}
	return NULL;
}

void
file_utils_save_to (GFile* file,
                    const gchar* text)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (file != NULL);
	g_return_if_fail (text != NULL);
	{
		gchar* path = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GFile* dir = NULL;
		const gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFileOutputStream* _tmp13_ = NULL;
		GFileOutputStream* _tmp14_;
		GDataOutputStream* data_stream = NULL;
		GDataOutputStream* _tmp15_;
		guint8* data = NULL;
		guint8* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_ = 0;
		guint8* _tmp18_;
		gint _tmp18__length1;
		guint8* _tmp19_;
		gint _tmp19__length1;
		gint data_length1;
		gint _data_size_;
		gint l = 0;
		guint8* _tmp20_;
		gint _tmp20__length1;
		glong written = 0L;
		if (g_file_query_exists (file, NULL)) {
			gchar* etag_out = NULL;
			guint8* text_data = NULL;
			guint8* _tmp0_;
			gint text_data_length1;
			gint _text_data_size_;
			guint8* _tmp1_ = NULL;
			gsize _tmp2_ = 0;
			gchar* _tmp3_ = NULL;
			guint8* _tmp4_;
			gint _tmp4__length1;
			_tmp0_ = g_new0 (guint8, 0);
			text_data = _tmp0_;
			text_data_length1 = 0;
			_text_data_size_ = text_data_length1;
			g_file_load_contents (file, NULL, &_tmp1_, &_tmp2_, &_tmp3_, &_inner_error0_);
			text_data = (g_free (text_data), NULL);
			text_data = _tmp1_;
			text_data_length1 = _tmp2_;
			_text_data_size_ = text_data_length1;
			_g_free0 (etag_out);
			etag_out = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				text_data = (g_free (text_data), NULL);
				_g_free0 (etag_out);
				goto __catch0_g_error;
			}
			_tmp4_ = text_data;
			_tmp4__length1 = text_data_length1;
			if (g_strcmp0 (text, (const gchar*) _tmp4_) == 0) {
				text_data = (g_free (text_data), NULL);
				_g_free0 (etag_out);
				return;
			}
			g_file_delete (file, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				text_data = (g_free (text_data), NULL);
				_g_free0 (etag_out);
				goto __catch0_g_error;
			}
			text_data = (g_free (text_data), NULL);
			_g_free0 (etag_out);
		}
		_tmp5_ = g_file_get_parent (file);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_file_get_parse_name (_tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		path = _tmp8_;
		_tmp9_ = path;
		_tmp10_ = g_file_new_for_path (_tmp9_);
		dir = _tmp10_;
		_tmp11_ = dir;
		if (!g_file_query_exists (_tmp11_, NULL)) {
			GFile* _tmp12_;
			_tmp12_ = dir;
			g_file_make_directory_with_parents (_tmp12_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (dir);
				_g_free0 (path);
				goto __catch0_g_error;
			}
		}
		_tmp14_ = g_file_create (file, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
		_tmp13_ = _tmp14_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (dir);
			_g_free0 (path);
			goto __catch0_g_error;
		}
		_tmp15_ = g_data_output_stream_new ((GOutputStream*) _tmp13_);
		data_stream = _tmp15_;
		_tmp16_ = string_get_data (text, &_tmp17_);
		_tmp16__length1 = _tmp17_;
		_tmp18_ = _tmp16_;
		_tmp18__length1 = _tmp16__length1;
		_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup3 (_tmp18_, _tmp18__length1) : _tmp18_;
		_tmp19__length1 = _tmp18__length1;
		data = _tmp19_;
		data_length1 = _tmp19__length1;
		_data_size_ = data_length1;
		_tmp20_ = data;
		_tmp20__length1 = data_length1;
		l = _tmp20__length1;
		written = (glong) 0;
		while (TRUE) {
			gssize _tmp21_ = 0L;
			GDataOutputStream* _tmp22_;
			guint8* _tmp23_;
			gint _tmp23__length1;
			guint8* _tmp24_;
			gint _tmp24__length1;
			if (!(written < ((glong) l))) {
				break;
			}
			_tmp22_ = data_stream;
			_tmp23_ = data;
			_tmp23__length1 = data_length1;
			_tmp24_ = data;
			_tmp24__length1 = data_length1;
			_tmp21_ = g_output_stream_write ((GOutputStream*) _tmp22_, _tmp23_ + ((gint) written), (gsize) (_tmp24__length1 - ((gint) written)), NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				data = (g_free (data), NULL);
				_g_object_unref0 (data_stream);
				_g_object_unref0 (_tmp13_);
				_g_object_unref0 (dir);
				_g_free0 (path);
				goto __catch0_g_error;
			}
			written += (glong) _tmp21_;
		}
		data = (g_free (data), NULL);
		_g_object_unref0 (data_stream);
		_g_object_unref0 (_tmp13_);
		_g_object_unref0 (dir);
		_g_free0 (path);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp25_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp25_ = e->message;
		g_error ("file_utils.vala:31: %s", _tmp25_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
file_utils_recursive_delete (GFile* path)
{
	GFileEnumerator* enumerator = NULL;
	GFileInfo* file_info = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (path != NULL);
	{
		GFileEnumerator* _tmp0_ = NULL;
		GFileEnumerator* _tmp1_;
		GFileEnumerator* _tmp2_;
		_tmp1_ = g_file_enumerate_children (path, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (enumerator);
		enumerator = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e->message;
		g_error ("file_utils.vala:42: %s", _tmp3_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (enumerator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	{
		GFileInfo* _tmp4_ = NULL;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		_tmp5_ = g_file_enumerator_next_file (enumerator, NULL, &_inner_error0_);
		_tmp4_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp6_ = _tmp4_;
		_tmp4_ = NULL;
		_g_object_unref0 (file_info);
		file_info = _tmp6_;
		_g_object_unref0 (_tmp4_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		g_clear_error (&_inner_error0_);
		_g_object_unref0 (file_info);
		file_info = NULL;
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (file_info);
		_g_object_unref0 (enumerator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp7_;
		GFile* child = NULL;
		GFileInfo* _tmp8_;
		GFile* _tmp9_;
		GFileInfo* _tmp10_;
		_tmp7_ = file_info;
		if (!(_tmp7_ != NULL)) {
			break;
		}
		_tmp8_ = file_info;
		_tmp9_ = g_file_enumerator_get_child (enumerator, _tmp8_);
		child = _tmp9_;
		_tmp10_ = file_info;
		if (g_file_info_get_file_type (_tmp10_) == G_FILE_TYPE_DIRECTORY) {
			GFile* _tmp11_;
			_tmp11_ = child;
			file_utils_recursive_delete (_tmp11_);
		} else {
			{
				GFile* _tmp12_;
				_tmp12_ = child;
				g_file_delete (_tmp12_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				g_clear_error (&_inner_error0_);
			}
			__finally2:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (child);
				_g_object_unref0 (file_info);
				_g_object_unref0 (enumerator);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		{
			GFileInfo* _tmp13_ = NULL;
			GFileInfo* _tmp14_;
			GFileInfo* _tmp15_;
			_tmp14_ = g_file_enumerator_next_file (enumerator, NULL, &_inner_error0_);
			_tmp13_ = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch3_g_error;
			}
			_tmp15_ = _tmp13_;
			_tmp13_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp15_;
			_g_object_unref0 (_tmp13_);
		}
		goto __finally3;
		__catch3_g_error:
		{
			g_clear_error (&_inner_error0_);
			_g_object_unref0 (file_info);
			file_info = NULL;
		}
		__finally3:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (child);
			_g_object_unref0 (file_info);
			_g_object_unref0 (enumerator);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_object_unref0 (child);
	}
	{
		g_file_delete (path, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (file_info);
		_g_object_unref0 (enumerator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (file_info);
	_g_object_unref0 (enumerator);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

gchar*
file_utils_expand_home_directory (const gchar* path)
{
	gchar* _tmp15_;
	gchar* result;
	g_return_val_if_fail (path != NULL, NULL);
	if (string_get (path, (glong) 0) == '~') {
		gchar* user_home = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gboolean _tmp2_ = FALSE;
		_tmp0_ = g_get_home_dir ();
		_tmp1_ = g_strdup (_tmp0_);
		user_home = _tmp1_;
		if (string_get (path, (glong) 1) != '/') {
			_tmp2_ = TRUE;
		} else {
			_tmp2_ = string_get (path, (glong) 1) != '/';
		}
		if (_tmp2_) {
			const gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp3_ = user_home;
			_tmp4_ = g_strconcat (_tmp3_, "/", NULL);
			_tmp5_ = _tmp4_;
			_tmp6_ = string_substring (path, (glong) 1, (glong) -1);
			_tmp7_ = _tmp6_;
			_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
			_tmp9_ = _tmp8_;
			_g_free0 (_tmp7_);
			_g_free0 (_tmp5_);
			result = _tmp9_;
			_g_free0 (user_home);
			return result;
		} else {
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp10_ = user_home;
			_tmp11_ = string_substring (path, (glong) 1, (glong) -1);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_strconcat (_tmp10_, _tmp12_, NULL);
			_tmp14_ = _tmp13_;
			_g_free0 (_tmp12_);
			result = _tmp14_;
			_g_free0 (user_home);
			return result;
		}
		_g_free0 (user_home);
	}
	_tmp15_ = g_strdup (path);
	result = _tmp15_;
	return result;
}

